# nnetflow Documentation

nnetflow is a minimal neural network framework with autodiff, inspired by micrograd and PyTorch. It provides a simple API for building and training neural networks using NumPy arrays and custom autodiff.

## Installation

```bash
pip install nnetflow
```

## Modules

- **nnetflow.engine**: Core Tensor and autodiff engine
- **nnetflow.nn**: Layers, MLP, optimizers, loss functions
- **nnetflow.optim**: Optimizers (SGD, etc.)

## Quick Example

See the [usage guide](usage.md) and [examples](../regression_problem_example.py, ../classification_example.py) for more details.

---
